<template>
    <div class="box__pc--element">
        <h2 class="bold-title">{{ payment_system.code }}</h2>
        <p class="text-podTitle">{{ payment_system.name }}</p>
        <p class="text-podTitle" style="color: #2e64e4">{{ formatted_balance }}</p>
        <p class="valuta">{{ payment_system.currency.code_iso }}</p>
        <div class="box-icon">
            <router-link :to="route('payment_systems_edit', {id: payment_system.id})">
                <svg class="edit">
                    <use xlink:href="/img/sprite.svg#edit"/>
                </svg>
            </router-link>
            <a href="#" @click.prevent="deletePaymentSystem">
                <svg class="delete">
                    <use xlink:href="/img/sprite.svg#cancel-button"/>
                </svg>
            </a>
            <a href="#" @click.prevent="getBalance">
                <svg class="load-balance" :class="{'spin-animate': is_loading}">
                    <use xlink:href="/img/sprite.svg#cycle-couple-of-arrows-hand-drawn-lines"/>
                </svg>
            </a>
        </div>
    </div>
</template>

<script>
    import {mapGetters} from 'vuex';
    import route from "../../mixins/route";
    import currencies from "../../currencies";

    export default {
        name: "PaymentSystem",
        props: ['payment_system', 'is_all_loading'],
        mixins: [route],
        data(){
            return {
                is_loading: this.is_all_loading,
                balance: this.payment_system.balance
            }
        },
        watch: {
            is_all_loading(val){
                this.is_loading = val;
            },
            payment_system(payment_system){
                this.balance = payment_system.balance;
            }
        },
        computed: {
            ...mapGetters([
                'axios'
            ]),
            formatted_balance(){
                return currencies.formatWithDefault(this.balance, this.payment_system.currency);
            }
        },
        methods: {
            deletePaymentSystem(){
                this.axios
                    .post(`payment_systems/${this.payment_system.id}/delete`)
                    .then(resp => resp.data)
                    .then(data => {
                        this.$swal(this.$t('ui.success'), data.message, 'success');
                        this.$emit('deleted', this.payment_system.id)
                    });
            },
            getBalance(){
                this.is_loading = true;
                this.$emit('loading', true);
                this.axios
                    .get(`payment_systems/${this.payment_system.id}/balance`)
                    .then(resp => resp.data)
                    .then(data => {
                        if(data.status === 'success'){
                            this.balance = data.balance;
                            this.$swal('Успешно', `Баланс получен ${currencies.formatWithDefault(data.balance, this.payment_system.currency)}`, 'success');
                        }else{
                            this.$swal(this.$t('ui.error'), `Ошибка при получении баланса`, 'error');
                        }
                    })
                    .finally(() => {
                        this.is_loading = false;
                        this.$emit('loading', false);
                    })
                ;
            },
        }

    }
</script>

<!--suppress CssUnusedSymbol -->
<style scoped>
    .load-balance{
        width: 20px;
        height: 20px;
        fill: #3069e9;
        margin-left: 25px;
    }
    .spin-animate{
        animation-name: spin;
        animation-duration: 1000ms;
        animation-iteration-count: infinite;
        animation-timing-function: linear;
    }
    @keyframes spin {
        from {
            transform:rotate(0deg);
        }
        to {
            transform:rotate(360deg);
        }
    }
</style>
